/*
		Copyright 2000-2002 Frdric Brown
*/

/*
		This file is part of CLib.

    CLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with CLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
	int		x,//Argument 1: the upperleft x coordinate
			y,//Argument 2: the upperleft y coordinate
			arg;//Argument 4: the drawing pattern
	char 	*chaine;//Argument 3: the string to display
	
	ESI argptr;//A pointer on the argument stack
	InitArgPtr(argptr);//Initialization of the argument pointer
	x = GetIntArg(argptr);//Assign argument 1 to x as int
	y = GetIntArg(argptr);//Assign argument 2 to y as int
	chaine = GetStrnArg(argptr);//Assign argument 3 to chaine as string
	arg = GetIntArg(argptr);//Assign argument 4 to arg as int
	
	//Depending on arg
	switch(arg) {
		case 0: {
			DrawStr(x, y, chaine, A_NORMAL);//Draws a normal string
			break;
		}
		case 1: {
			DrawStr(x, y, chaine, A_REVERSE);//Draws a opaque white on black string
			break;
		}
		case 2: {
			DrawStr(x, y, chaine, A_REPLACE);//Draws a opaque black on white string
			break;
		}
		case 3: {
			DrawStr(x, y, chaine, A_XOR);//Draws a xor string
			break;
		}
		case 4: {
			DrawStr(x, y, chaine, A_SHADED);//Draws a shaded string
			break;
		}
	}
}
