/*
		Copyright 2000-2002 Frdric Brown
*/

/*
		This file is part of CLib.

    CLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with CLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

void DRAWLINE(int x0, int y0, int x1, int y1, int arg)
{
	//Depending on arg
	switch (arg) {
		case 0: {
			DrawLine(x0, y0, x1, y1, A_NORMAL);//Draws a normal line
			break;
		}
		case 1: {
			DrawLine(x0, y0, x1, y1, A_REVERSE);//Draws a reverse line
			break;
		}
		case 2: {
			DrawLine(x0, y0, x1, y1, A_XOR);//Draws a xor line
			break;
		}
		case 3: {
			DrawLine(x0, y0, x1, y1, A_THICK1);//Draws a double thick line
			break;
		}
		case 4: {
			DrawLine(x0, y0, x1, y1, A_SHADE_V);//Draws the line using a vertical shading pattern
			break;
		}
		case 5: {
			DrawLine(x0, y0, x1, y1, A_SHADE_H);//Draws the line using a horizontal shading pattern
			break;
		}
		case 6: {
			DrawLine(x0, y0, x1, y1, A_SHADE_NS);//Draws the line using a negative slope diagonal shading pattern
			break;
		}
		case 7: {
			DrawLine(x0, y0, x1, y1, A_SHADE_PS);//Draws the line using a positive slope diagonal shading pattern
			break;
		}
	}
}

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
	int nbrParam,//Argument 1: the number of coordinates (sum of the x and y coordinates (a square will have 10 ex: 0,0;10,0;10,10;0,10;0,0))
		arg,//Argument 2: the drawing patern
		x0,//Will contain the first x coordinate
		y0,//Will contain the first y coordinate
		x1,//Will contain the second x coordinate
		y1,//Will contain the second y coordinate
		i;//Will be used by the for as counter
	
	ESI argptr;//A pointer on the argument stack
	InitArgPtr(argptr);//Initialization of the argument pointer
	nbrParam = GetIntArg(argptr);//Assign argument 1 to nbrParam as int
	arg = GetIntArg(argptr);//Assign argument 2 to arg as int
	x1 = GetIntArg(argptr);//Assign argument 3 to x1 as int
	y1 = GetIntArg(argptr);//Assign argument 4 to y1 as int

	for (i=0; i<nbrParam-1; i++)
	{
		//The last second coordinates become the new first
		x0 = x1;
		y0 = y1;
		x1 = GetIntArg(argptr);//Get the new second x coordinate
		y1 = GetIntArg(argptr);//Get the new second y coordinate
		
		DRAWLINE(x0, y0, x1, y1, arg);//Draws the line
	}
}
