/*
		Copyright 2000-2002 Frdric Brown
*/

/*
		This file is part of CLib.

    CLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with CLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
//#include <CLib.h>

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File
/*
	Merges 2 string
*/
char* mergestr(char *str0, char *str1, int len0, int len1, int pos)
{
	int i,//Will be used by the for as a counter
	    point0 = 0,//Will contain the current index on the first string
	    point1 = 0;//Will contain the current index on the string to insert
	char *array = malloc(len0 + len1 + 1);//Allocate memory for the new string (+1 is for the null terminating character)
	char array0[len0 + 1];//A buffer to contain the first string
	char array1[len1 + 1];//A buffer to contain the string to insert
	
  strcpy(array0, str0);//Copy the first string in the buffer
  strcpy(array1, str1);//Copy the string to insert in the buffer
  
  //for each characters, from 0 to the sum of the length of both string
  for (i=0; i<(len0 + len1); i++)
  {
  	//If i is lesser than the offset of if i is greater than the length of the string to insert + the offset
   	if ((i < pos && point0 < len0) || (!(i >= pos && point1 < len1) && (point0 < len0)))
   	{
   		array[i] = array0[point0++];//take a char in the first string and insert it in the new string, then increment the current index of the first string
   	}
   	else
   	{
   		array[i] = array1[point1++];//take a char in the string to insert and insert it in the new string, then increment the current index of the string to insert
   	}
  }
  
  array[i] = '\0';

	return array;
}

// Main Function
void _main(void)
{
	char *str0,//Argument 1: the first string
			 *str1,//Argument 2: the string to insert
			 *str,//The new string
			 *output_string;//The string in TIOS format
	int	pos;//Argument 3: the offset where to insert the string
		
	ESI argptr;//A pointer on the argument stack
	InitArgPtr(argptr);//Initialization of the argument pointer
	
	str0 = GetStrnArg(argptr);//Assign argument 1 to str0 as string
	str1 = GetStrnArg(argptr);//Assign argument 2 to str1 as string
	pos = GetIntArg(argptr);//Assign argument 3 to pos as int
	
	str = mergestr(str0, str1, strlen(str0), strlen(str1), pos);//Merges the string
	
	//push_ANSI_string(str);
	
	output_string = malloc(strlen(str) + 2);
	//put the zero at the beginning of the string
	output_string[0] = 0;
	//copy the string, including the terminating zero, to the output string
	strcpy(output_string + 1, str);
	
	//put the string, with all spaces intact, on the expression stack
	push_expr_quantum(output_string + strlen(output_string + 1) + 1, STR_TAG);
	
	//always make sure to free your memory
	free(output_string);
	free(str);//Frees the memory allocated to the new string
}
