/*
		Copyright 2000-2002 Frdric Brown
*/

/*
		This file is part of CLib.

    CLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with CLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
//#include <CLib.h>

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
	char *str0,//Argument 1: the first string
			 *str1;//Argument 2: the string to find
	int	ind = -1,//The index of the string in the first string
			pos,//Will be used by the for to browse the first string
			cur,//Will be used to browse a part of the first string
			ptr,//Will be used to mark where begins the string in the first string
			length0,//Will contain the length of the first string
			length1;//Will contain the length of the string to find
			
	ESI argptr;//A pointer on the argument stack
	InitArgPtr(argptr);//Initialization of the argument pointer
	
	str0 = GetStrnArg(argptr);//Assign argument 1 to str0 as string
	str1 = GetStrnArg(argptr);//Assign argument 2 to str1 as string

	length0 = strlen(str0);//Assign to length0 the length of str0
	length1 = strlen(str1);//Assign to length0 the length of str1

	//for each character of the string, backward, from the length of the string -1 to 0
	for (pos = (length0 - 1); pos >= 0; pos--) {
		cur = pos - length1 + 1;//Begin to search from the current position minus the length of the string to find
		ptr = cur;//Mark the initial position
		
		//while cur is lesser than the length of the string to find and the character at cur in the string is equal to the character at cur - ptr in the string to find
		while (str0[cur] == str1[cur - ptr] && cur < length0) {
			cur++;//Increment cur
		}
		
		//If cur-ptr equals the length of the string to find that means the string is found
		if ((cur - ptr) == length1) {
			ind = ptr;//Asign the initial position as index
			break;//Exits the for
		}
	}
	
	push_longint(ind);//Returns the index
}
