/*
		Copyright 2000-2002 Frdric Brown
*/

/*
		This file is part of CLib.

    CLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with CLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
	char *str,//Argument 1: the string to convert
			 *output_string;//The string in TIOS format
	int i,//Used by the for as a counter
	    len;//Will contain the length of the string
		
	ESI argptr;//A pointer on the argument stack
	InitArgPtr(argptr);//Initialization of the argument pointer
	
	str = GetStrnArg(argptr);//Assign argument 1 to str as string
	
	len = strlen(str);//Assign the length of str to len
	
	//For each character of str
	for (i=0; i<len; i++)
	{
		//If the character is uppercase
		if (str[i] <= 90 && str[i] >= 65)
		{
			str[i] = str[i] + 32;//Converts the character to lower case
		}
	}
	
	//push_ANSI_string(str);
	
	output_string = malloc(strlen(str) + 2);
	//put the zero at the beginning of the string
	output_string[0] = 0;
	//copy the string, including the terminating zero, to the output string
	strcpy(output_string + 1, str);
	
	//put the string, with all spaces intact, on the expression stack
	push_expr_quantum(output_string + strlen(output_string + 1) + 1, STR_TAG);
	
	//always make sure to free your memory
	free(output_string);
}
