/*
		Copyright 2000-2002 Frdric Brown
*/

/*
		This file is part of CLib.

    CLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with CLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
	BOOL fin = FALSE;//A flag that will indicate if there is no more non-space characters
	BOOL trouve;//A flag that will indicate if the first or the last non-space character is found
	char *str,//Argument 1: the string to convert
			 *output_string;//The string in TIOS format
	int i,//Used by the for as a counter
	    len,//Will contain the length of the string
	    point0,//Will contain the index of the first non-space character
	    point1;//Will contain the index of the last non-space character
		
	ESI argptr;//A pointer on the argument stack
	InitArgPtr(argptr);//Initialization of the argument pointer
	
	str = GetStrnArg(argptr);//Assign argument 1 to str as string
	
	len = strlen(str);//Assign the length of str to len
	
	point0 = 0;//Initialize the forward index
	point1 = len - 1;//Initialize the backward index
	
	/*
		Removes all the spaces at the begining
	*/
	trouve = FALSE;
	
	for (i=0; i<len && !trouve; i++)
	{
		if (str[i] != ' ')
		{
			point0 = i;
			trouve = TRUE;
		}
	}
	
	/*
		Removes all the spaces at the begining
	*/	
	trouve = FALSE;
	
	for (i=len - 1; i>=0 && !trouve; i--)
	{
		if (str[i] != ' ')
		{
			point1 = i;
			trouve = TRUE;
		}
	}
	
	//for each character of the trimmed string, from 0 to the size of the non-space characters
	for (i=0; i<len && !fin; i++)
	{
		//If the character isn't a space
		if (i >= point0 && i <= point1)
		{
			str[i - point0] = str[i];//Adds the character to the string
		}
		//Else if the character index is greater than the last index of non-space characters
		else if (i > point1)
		{
			fin = TRUE;//Exits the for next loop
		}
	}
	
	str[point1 - point0 + 1] = '\0';//Adds the null terminating character
	
	//push_ANSI_string(str);
	
	output_string = malloc(strlen(str) + 2);
	//put the zero at the beginning of the string
	output_string[0] = 0;
	//copy the string, including the terminating zero, to the output string
	strcpy(output_string + 1, str);
	
	//put the string, with all spaces intact, on the expression stack
	push_expr_quantum(output_string + strlen(output_string + 1) + 1, STR_TAG);
	
	//always make sure to free your memory
	free(output_string);
}
