/*
		Copyright 2000-2002 Frdric Brown
*/

/*
		This file is part of CLib.

    CLib is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with CLib; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
	char *str,//Argument 1: The string
			 *sub,//The substring to be returned
			 *output_string;//Will contain the substring in TIOS format
	int offset,//Argument 2: The offset where the substring start
			length,//Argument 3: The length of the substring
			i,//A simple counter that will be used by the for
	    len;//Will contain the length of the string
	
	ESI argptr;//A pointer on the argument stack
	InitArgPtr(argptr);//Initialization of the argument pointer
	
	str = GetStrnArg(argptr);//Assign argument 1 to str as string
	offset = GetIntArg(argptr);//Assign argument 2 to offset as int
	length = GetIntArg(argptr);//Assign argument 3 to offset as int
	
	len = strlen(str);//Assign the length of the string to len
	
	//If the parameters are OK ...
	if (length <= (len - offset) && length > 0) {
		sub = malloc(length + 1); //Assign length + 1 bytes of memory to sub (+1 is for the null terminating character)
		//For each character in the string, from the offset to the offset + length of the substring -1
		for (i = offset; i < offset + length; i++) {
			sub[i - offset] = str[i];//Assing the character at position i in the string to the position i - offset in the substring
		}
		sub[i - offset] = '\0';//Ends the substring by the null character
	}
	else {
		sub = NULL;
	}
	
	//push_ANSI_string(sub);
	
	output_string = malloc(strlen(sub) + 2);
	//put the zero at the beginning of the string
	output_string[0] = 0;
	//copy the string, including the terminating zero, to the output string
	strcpy(output_string + 1, sub);
	
	//put the string, with all spaces intact, on the expression stack
	push_expr_quantum(output_string + strlen(output_string + 1) + 1, STR_TAG);
	
	//always make sure to free your memory
	free(output_string);
	//If the string is not equal to NULL
	if (!str) {
		free(str); //Free the memory allocated
	}
}
